SystemOrganization addCategory: #'SourceCity-Importer'!

Object subclass: #AbstractSourceCityImporterStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!AbstractSourceCityImporterStrategy commentStamp: '<historical>' prior: 0!
I'm the object which is needed to SourceCityImporter!

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:34'!
buildingGap
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:32'!
buildingNameGenerator
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:30'!
buildingsSelector
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
cityWidth
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/12/2012 10:22'!
dependenciesSelector
"must return an OrderedCollection"
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:34'!
districtGap
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:34'!
districtNameGenerator
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
districtWidth
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:30'!
districtsSelector
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:21'!
normalizedBuildingDimension
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 10:58'!
normalizedColor
	self subclassResponsibility! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterDefaultStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterDefaultStrategy commentStamp: '<historical>' prior: 0!
I'm the default use of AbstractSourceCityImporter!

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 00:22'!
buildingsSelector 
	#classes! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'blo 7/4/2012 10:26'!
heightNormalizer
	^ [:height | 2 * (height sqrt)]! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'blo 7/4/2012 10:33'!
heightSelector
	^ [:anObject | (anObject selectors size)]! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
lowColor
	^Color green! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
maxColor
	^Color red! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
maxLevel
	^50! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'blo 7/4/2012 10:39'!
normalizedHeight
	^ [:anObject | (anObject perform: self heightSelector) perform: (self heightNormalizer)]! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:33'!
widthNormalizer
	^#sqrt! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:32'!
widthSelector
	^#allInstVarNames! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterPackageInfoStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterPackageInfoStrategy commentStamp: '<historical>' prior: 0!
I'm a strategy to use with PackageInfo importation!

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
buildingGap
	^ 2! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:36'!
buildingNameGenerator
	^ [:anObject | anObject]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:31'!
buildingsSelector 
	^ [:anObject | anObject classes]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 11:08'!
calculMix: color1 at: color1Perc and: color2 at: color2Perc
	
	^Color r: ((color1 red * color1Perc) + (color2 red * color2Perc))
				g: ((color1 green * color1Perc) + (color2 green * color2Perc))
				b: ((color1 blue * color1Perc) + (color2 blue * color2Perc))! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 11:04'!
calculRatio: anObject
	^ (self normalizedHeight value: anObject) / (self maxLevel)! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 14:42'!
cityWidth
	^ [:aCity | ((aCity districts inject: 0 into: [:sum :aDistrict | sum + (aDistrict dimension x + (2 * self districtGap)) ]) /(1+ aCity districts size sqrt )   *2 asFloat roundedUp)]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/12/2012 12:09'!
dependenciesSelector

	^ [:anObject | self findDependencies: anObject ] ! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:35'!
districtGap
	^ 2! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 12:57'!
districtNameGenerator
	^ [:anObject | anObject asString]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/7/2012 22:15'!
districtWidth
	^ [:aDistrict | ((aDistrict buildings inject: 0 into: [:max :aBuilding | max max: aBuilding dimension x]) + (2 * self buildingGap)) 
		max: (((aDistrict buildings inject: 0 into: [:sum :aBuilding | sum + (aBuilding dimension x + (2 * self buildingGap)) ]) /(1+aDistrict buildings size sqrt))  asFloat roundedUp)]
		
		
		! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 14:31'!
districtsSelector 
	^ [:anObject | anObject]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/12/2012 12:07'!
findDependencies: anObject 
	| aCollectiion  |
	aCollectiion  :=  OrderedCollection new.
	anObject subclasses  collect: [:each | aCollectiion  add: each name asString ].
	^aCollectiion ! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 11:12'!
heightNormalizer
	^ [:height | 0.5 max: (2 * (height sqrt))]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 10:41'!
heightSelector
	^ [:anObject | (anObject selectors size)]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/3/2012 11:32'!
lowColor
	^Color green! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/3/2012 11:32'!
maxColor
	^Color red! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 11:10'!
maxLevel
	^ self heightNormalizer value: 50! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/5/2012 11:23'!
normalizedBuildingDimension
	^ [:anObject | Point3D x: (self normalizedXWidth value: anObject)
		y: (self normalizedHeight value: anObject)
		z: (self normalizedZWidth value: anObject) ]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'strategy' stamp: 'blo 7/4/2012 11:12'!
normalizedColor
	|ratio|
	^ [:anObject | ratio := self calculRatio: anObject. 
		(ratio > 1) 
			ifTrue: [self maxColor] 
			ifFalse:[self calculMix: self lowColor at: (1-ratio) and: self maxColor at: (ratio)]].! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 16:15'!
normalizedHeight
	^ [:anObject |  1 max: ((self heightNormalizer) value: (self heightSelector value: anObject)) ]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 16:15'!
normalizedXWidth
	^ [:anObject | 1 max: ((self widthNormalizer) value: (self widthSelector value: anObject)) ]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 16:15'!
normalizedZWidth
	^ [:anObject | 1 max: ((self widthNormalizer) value: (self widthSelector value: anObject)) ]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/5/2012 11:11'!
widthNormalizer
	^ [:width | 0.5 max: (2 * (width sqrt))]! !

!SourceCityImporterPackageInfoStrategy methodsFor: 'tools' stamp: 'blo 7/4/2012 10:55'!
widthSelector
	^ [:anObject | (anObject allInstVarNames size)].! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterRPackageStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterRPackageStrategy commentStamp: '<historical>' prior: 0!
I'm a strategy to use with Rpackage importation!

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 8/20/2012 14:33'!
buildingGap
	^ 5! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 15:02'!
buildingNameGenerator
	^ [:anObject | anObject asString]! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 15:01'!
buildingsSelector 
	^ [:anObject | (RPackageOrganizer default packageNamed: anObject ) classes]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
calculMix: color1 at: color1Perc and: color2 at: color2Perc
	
	^Color r: ((color1 red * color1Perc) + (color2 red * color2Perc))
				g: ((color1 green * color1Perc) + (color2 green * color2Perc))
				b: ((color1 blue * color1Perc) + (color2 blue * color2Perc))! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
calculRatio: anObject
	^ (self normalizedHeight value: anObject) / (self maxLevel)! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 14:49'!
cityWidth
	^ [:aCity | ((aCity districts inject: 0 into: [:sum :aDistrict | sum + (aDistrict dimension x + (2 * self districtGap)) ]) /(1+ aCity districts size sqrt )   *2 asFloat roundedUp)]! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/12/2012 10:22'!
dependenciesSelector

	^ [:anObject | self findDependencies: anObject ]! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 8/20/2012 14:23'!
districtGap
	^ 5! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 15:00'!
districtNameGenerator
	^ [:anObject | RPackageOrganizer default packageNamed: anObject]! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 14:49'!
districtWidth
	^ [:aDistrict | ((aDistrict buildings inject: 0 into: [:max :aBuilding | max max: aBuilding dimension x]) + (2 * self buildingGap)) 
		max: (((aDistrict buildings inject: 0 into: [:sum :aBuilding | sum + (aBuilding dimension x + (2 * self buildingGap)) ]) /(1+aDistrict buildings size sqrt))  asFloat roundedUp)]
		
		
		! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 14:49'!
districtsSelector 
	^ [:anObject | anObject]! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/24/2012 14:07'!
findDependencies: anObject 
	| aCollectiion  |
	aCollectiion  :=  OrderedCollection new.
	anObject subclasses  collect: [:each | aCollectiion  add: each name asString ].
	^aCollectiion ! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/31/2012 15:50'!
heightNormalizer
	^ [:height | 0.5 max: (2 * (height sqrt))]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
heightSelector
	^ [:anObject | (anObject selectors size)]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
lowColor
	^Color green! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 8/9/2012 13:35'!
maxColor
	^Color red
! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
maxLevel
	^ self heightNormalizer value: 50! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 14:49'!
normalizedBuildingDimension
	^ [:anObject | Point3D x: (self normalizedXWidth value: anObject)
		y: (self normalizedHeight value: anObject)
		z: (self normalizedZWidth value: anObject) ]! !

!SourceCityImporterRPackageStrategy methodsFor: 'strategy' stamp: 'DouailleErwan 7/9/2012 14:49'!
normalizedColor
	|ratio|
	^ [:anObject | ratio := self calculRatio: anObject. 
		(ratio > 1) 
			ifTrue: [self maxColor] 
			ifFalse:[self calculMix: self lowColor at: (1-ratio) and: self maxColor at: (ratio)]].! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
normalizedHeight
	^ [:anObject |  1 max: ((self heightNormalizer) value: (self heightSelector value: anObject)) ]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
normalizedXWidth
	^ [:anObject | 1 max: ((self widthNormalizer) value: (self widthSelector value: anObject)) ]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
normalizedZWidth
	^ [:anObject | 1 max: ((self widthNormalizer) value: (self widthSelector value: anObject)) ]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
widthNormalizer
	^ [:width | 0.5 max: (2 * (width sqrt))]! !

!SourceCityImporterRPackageStrategy methodsFor: 'tools' stamp: 'DouailleErwan 7/9/2012 14:49'!
widthSelector
	^ [:anObject | (anObject allInstVarNames size)].! !

Object subclass: #ManifestSourceCityImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 13:25'!
rejectClasses
^ #()! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 13:25'!
rejectRules
^ #()! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:58'!
ruleAllAnyNoneSatisfyRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SourceCityImporter #ensureDistrictAbsent: #false)) #'2012-08-30T14:58:50.619+02:00') #(#(#RGMethodDefinition #(#SourceCityImporter #ensureBuildingAbsent: #false)) #'2012-08-30T14:58:50.619000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:26'!
ruleClassNotReferencedRuleV1FalsePositive
^ #(#(#(#RGClassDefinition #(#SourceCityImporterDefaultStrategy)) #'2012-08-30T14:26:31.05+02:00') #(#(#RGClassDefinition #(#SourceCityImporterRPackageStrategy)) #'2012-08-30T14:26:31.051+02:00') #(#(#RGClassDefinition #(#SourceCityImporter)) #'2012-08-30T14:26:31.052+02:00') #(#(#RGClassDefinition #(#SourceCityImporterPackageInfoStrategy)) #'2012-08-30T14:26:31.052000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:44'!
ruleCollectSelectNotUsedRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #findDependencies: #false)) #'2012-08-30T14:44:36.823+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #findDependencies: #false)) #'2012-08-30T14:44:36.823000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:49'!
ruleCollectionMessagesToExternalObjectRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporter #categorizeCity: #false)) #'2012-08-30T14:49:15.475+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:50'!
ruleCollectionProtocolRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporter #categorizeDistrict: #false)) #'2012-08-30T14:50:02.438+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:50'!
ruleDetectContainsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporter #ensureDistrictAbsent: #false)) #'2012-08-30T14:50:20.255+02:00') #(#(#RGMethodDefinition #(#SourceCityImporter #ensureBuildingAbsent: #false)) #'2012-08-30T14:50:22.149+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:18'!
ruleImplementedNotSentRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'SourceCityImporter class' #title:strategy:import: #true)) #'2012-08-30T14:17:44.263+02:00') #(#(#RGMethodDefinition #(#AbstractSourceCityImporterStrategy #cityWidth #false)) #'2012-08-30T14:18:17.669+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #cityWidth #false)) #'2012-08-30T14:18:32.973+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #districtWidth #false)) #'2012-08-30T14:18:34.807+02:00') #(#(#RGMethodDefinition #(#SourceCityImporter #buildings: #false)) #'2012-08-30T14:18:40.982+02:00') #(#(#RGMethodDefinition #(#SourceCityImporter #districts: #false)) #'2012-08-30T14:18:44.316+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #cityWidth #false)) #'2012-08-30T14:18:48.961+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #districtWidth #false)) #'2012-08-30T14:18:52.631+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:52'!
ruleInconsistentMethodClassificationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #buildingsSelector #false)) #'2012-08-30T14:51:52.982+02:00') #(#(#RGMethodDefinition #(#AbstractSourceCityImporterStrategy #buildingsSelector #false)) #'2012-08-30T14:52:30.52+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:48'!
ruleLawOfDemeterRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #districtWidth #false)) #'2012-08-30T14:47:36.277+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #cityWidth #false)) #'2012-08-30T14:47:36.277000001+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #cityWidth #false)) #'2012-08-30T14:48:18.503+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #districtWidth #false)) #'2012-08-30T14:48:18.503000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:49'!
ruleMissingSubclassResponsibilityRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #normalizedHeight #false)) #'2012-08-30T14:48:53.718+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #maxLevel #false)) #'2012-08-30T14:48:53.718000001+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #heightNormalizer #false)) #'2012-08-30T14:48:53.718000002+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #lowColor #false)) #'2012-08-30T14:48:53.718000003+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #maxColor #false)) #'2012-08-30T14:48:53.718000004+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #widthSelector #false)) #'2012-08-30T14:48:53.718000005+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #heightSelector #false)) #'2012-08-30T14:48:53.718000006+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #maxLevel #false)) #'2012-08-30T14:48:58.078+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #heightNormalizer #false)) #'2012-08-30T14:48:58.078000001+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #maxColor #false)) #'2012-08-30T14:48:58.078000002+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #lowColor #false)) #'2012-08-30T14:48:58.078000003+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #widthSelector #false)) #'2012-08-30T14:48:58.078000004+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #heightSelector #false)) #'2012-08-30T14:48:58.078000005+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #normalizedHeight #false)) #'2012-08-30T14:48:58.078000006+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #lowColor #false)) #'2012-08-30T14:49:02.965+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #maxColor #false)) #'2012-08-30T14:49:02.965000001+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #normalizedHeight #false)) #'2012-08-30T14:49:02.965000002+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #heightSelector #false)) #'2012-08-30T14:49:02.965000003+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #heightNormalizer #false)) #'2012-08-30T14:49:02.965000004+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #maxLevel #false)) #'2012-08-30T14:49:02.965000005+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #widthSelector #false)) #'2012-08-30T14:49:02.965000006+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterDefaultStrategy #widthNormalizer #false)) #'2012-08-30T14:49:02.965000007+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:33'!
ruleModifiesCollectionRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporter #categorizeCity: #false)) #'2012-08-30T14:33:06.898+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:23'!
ruleOnlyReadOrWrittenTemporaryRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineCityLayout:strategy: #true)) #'2012-08-30T14:23:25.341+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 13:30'!
ruleOnlyReadOrWrittenVariableRuleV1TODO
^ #(#(#(#RGClassDefinition #(#SourceCityImporter)) #'2012-08-30T13:30:05.741+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:42'!
ruleSentNotImplementedRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineDistrictLayout:strategy: #true)) #'2012-08-30T14:42:25.261+02:00') #(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineCityLayout:strategy: #true)) #'2012-08-30T14:42:25.261000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:42'!
ruleSubclassResponsibilityNotDefinedRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#AbstractSourceCityImporterStrategy #cityWidth #false)) #'2012-08-30T14:42:48.645+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:55'!
ruleUnclassifiedMethodsRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineDistrictLayout:strategy: #true)) #'2012-08-30T14:55:41.279+02:00') #(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineCityLayout:strategy: #true)) #'2012-08-30T14:55:41.279000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:29'!
ruleUnreferencedVariablesRuleV1TODO
^ #(#(#(#RGClassDefinition #(#SourceCityImporter)) #'2012-08-30T14:29:00.168+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:56'!
ruleUtilityMethodsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #calculMix:at:and:at: #false)) #'2012-08-30T14:56:52.086+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #findDependencies: #false)) #'2012-08-30T14:56:52.088+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #calculMix:at:and:at: #false)) #'2012-08-30T14:56:56.508+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterRPackageStrategy #findDependencies: #false)) #'2012-08-30T14:56:56.508000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:56'!
ruleUtilityMethodsRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #calculMix:at:and:at: #false)) #'2012-08-30T14:56:48.723+02:00') #(#(#RGMethodDefinition #(#SourceCityImporterPackageInfoStrategy #findDependencies: #false)) #'2012-08-30T14:56:48.723000001+02:00') )! !

!ManifestSourceCityImporter class methodsFor: 'meta data' stamp: 'DouailleErwan 8/30/2012 14:43'!
ruleVariableNotDefinedRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineDistrictLayout:strategy: #true)) #'2012-08-30T14:43:32.514+02:00') #(#(#RGMethodDefinition #(#'SourceCityLayout class' #defineCityLayout:strategy: #true)) #'2012-08-30T14:43:32.514000001+02:00') #(#(#RGMethodDefinition #(#SourceCityImporter #import:strategy:named: #false)) #'2012-08-30T14:43:32.514000002+02:00') )! !

Object subclass: #SourceCityImporter
	instanceVariableNames: 'city districts buildings sourceCityMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!SourceCityImporter class methodsFor: 'default-model' stamp: 'blo 7/4/2012 14:42'!
title: aCityName strategy: aSourceCityImporterStrategy import: anObject
	^ self new 
		import: anObject strategy: aSourceCityImporterStrategy named: aCityName! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
buildings
	^ buildings! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
buildings: anObject
	buildings := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 8/12/2012 11:53'!
categorizeCity: aCity
	"ensure there is not duplicated element and provide an id for each one"
	aCity districts do: [:aDistrict | 
		(self ensureDistrictAbsent: aDistrict) 
		ifTrue: [districts add: aDistrict. self categorizeDistrict: aDistrict] 
		ifFalse: [aCity districts remove: aDistrict ]]! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwn 8/14/2012 10:55'!
categorizeDistrict: aDistrict
	"ensure there is not duplicated element and provide an id for each one"
	aDistrict buildings do: [:aBuilding | 
		(self ensureBuildingAbsent: aBuilding) 
		ifTrue: [buildings add: aBuilding] "
		ifFalse: [aDistrict buildings remove: aBuilding. ]"]! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
city
	^ city! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
city: anObject
	city := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
districts
	^ districts! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
districts: anObject
	districts := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwn 8/14/2012 10:46'!
ensureBuildingAbsent: aBuilding
	(buildings do:[:each |
		each name = aBuilding name
		ifTrue: [^false]]).
	^true.
	" ifFalse: ] includes: aBuilding name [:d | d = aDistrict]) not	"	! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwn 8/14/2012 10:50'!
ensureDistrictAbsent: aDistrict
	(districts do:[:each |
		each name = aDistrict name
		ifTrue: [^false]]).
	^true.! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 8/9/2012 15:51'!
import: anObject strategy: aStrategy named: aName
	self city: (SourceCityFactory createCity: anObject named: aName strategy: aStrategy).
	self categorizeCity: city.
	SourceCityLayout defineCityLayout: city strategy: aStrategy .
! !

!SourceCityImporter methodsFor: 'initialize-release' stamp: 'blo 7/5/2012 14:14'!
initialize
	super initialize.
	districts := OrderedCollection new.
	buildings := OrderedCollection new.! !

Object subclass: #SourceCityLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityLayout commentStamp: '<historical>' prior: 0!
My job is to correctly give for each city's element a position and set properly any dimension!

!SourceCityLayout class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/12/2012 11:50'!
defineCityLayout: aCity strategy: aStrategy
	| x z zMax cityWidth districtGap xMax currentDirection previousDirection |
		
	aCity districts do: [:aDistrict | self defineDistrictLayout: aDistrict strategy: aStrategy].
		
	aCity position: (Point3D x: 0 y: 0 z: 0); 
		dimension:( (SourceCitySquareLayout gap: aStrategy districtGap)
			layoutCollection: (aCity districts sort: [:a :b | a dimension x > b dimension x])
			origin: (Point3D x: 0 y: 0 z: 0)).! !

!SourceCityLayout class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/20/2012 14:22'!
defineDistrictLayout: aDistrict strategy: aStrategy
	
	aDistrict position: (Point3D x: 0 y: 0 z: 0); 
		dimension:( 
			(SourceCitySquareLayout gap: aStrategy buildingGap )
				layoutCollection: (aDistrict buildings sort: [:a :b | a dimension x > b dimension x])
				origin: (Point3D x: 0 y: 0 z: 0)).! !
